<template>
  <div>
    <b-card align="right">
      <b-button-group>
        <b-button variant="primary" @click="refreshMinion"
          >Refresh minion information</b-button
        >
        <b-button variant="outline-primary" @click="refresh"
          ><b-icon icon="arrow-clockwise" aria-hidden="true"></b-icon
        ></b-button>
      </b-button-group>
    </b-card>

    <b-card v-if="minion" no-body>
      <b-tabs card>
        <b-tab title="Common" active>
          <b-table-lite
            :items="items.common"
            thead-class="hidden-header"
          ></b-table-lite>
        </b-tab>

        <b-tab title="Hardware">
          <b-table-lite
            :items="items.hardware"
            thead-class="hidden-header"
          ></b-table-lite>
        </b-tab>

        <b-tab title="Network">
          <b-table-lite
            :items="items.network"
            thead-class="hidden-header"
          ></b-table-lite>
        </b-tab>

        <b-tab title="Grains">
          <json-viewer :value="minion.grains" boxed expanded copyable sort />
        </b-tab>

        <b-tab title="Pillars">
          <json-viewer :value="minion.pillars" boxed expanded copyable sort />
        </b-tab>
      </b-tabs>
    </b-card>
  </div>
</template>

<script>
import JsonViewer from 'vue-json-viewer'

import * as errors from '~/utils/errors.js'
import * as toast from '~/utils/toast.js'

export default {
  middleware: ["auth"],
  components: {
    'json-viewer': JsonViewer,
  },
  computed: {
    minion() {
      return this.$store.getters['salt/minion'](this.$route.params.minion_id)
    },
    items() {
      const m = JSON.parse(JSON.stringify(this.minion))

      delete m.grains.hwaddr_interfaces.lo

      return {
        common: [
          { key: 'ID', value: m.minion_id },
          { key: 'Image', value: m.grains.image },
          { key: 'Room', value: m.grains.room },
          { key: 'Site', value: m.grains.site },
          { key: 'FQDN', value: m.grains.fqdn },
          { key: 'OS', value: m.grains.os },
          { key: 'Last job', value: m.last_job },
        ],
        hardware: [
          { key: 'CPU Model', value: m.grains.cpu_model },
          { key: 'CPU Number', value: m.grains.num_cpus },
          { key: 'RAM', value: (m.grains.mem_total / 1000).toFixed() },
          { key: 'GPU Number', value: m.grains.num_gpus },
          { key: 'Virtual', value: m.grains.virtual },
        ],
        network: [
          {
            key: 'Interfaces',
            value: Object.entries(m.grains.hwaddr_interfaces)
              .map(([key, value]) => `${key}: ${value}`)
              .join(', '),
          },
          { key: 'IPv4', value: m.grains.ipv4.join(', ') },
          { key: 'IPv6', value: m.grains.ipv6.join(', ') },
          { key: 'Nameservers', value: m.grains.dns.nameservers.join(', ') },
          { key: 'Domain', value: m.grains.dns.domain },
        ],
      }
    },
  },
  mounted() {
    this.refresh(null)
  },
  methods: {
    async refresh(event) {
      await this.$store
        .dispatch('salt/getMinions', this.$route.params.minion_id)
        .catch(errors.handleError(this))
    },

    async refreshMinion(event) {
      toast.toast(
        this,
        'Refreshing minion information',
        'Please wait a few seconds...',
        'info'
      )

      await this.$store
        .dispatch('salt/refreshMinion', this.$route.params.minion_id)
        .catch(errors.handleError(this))
      await this.refresh(null)

      toast.toast(this, 'Minion has been refreshed', ' ', 'success')
    },
  },
}
</script>

<style>
.hidden-header {
  display: none;
}

.jv-container {
  background: rgb(255 255 255 / 2%) !important;
  color: #fff !important;
}

.jv-key {
  color: #fff !important;
}

.jv-array {
  color: #fff !important;
}

.jv-object {
  color: #fff !important;
}
</style>
